#include <stdio.h>
#include <string.h>
#include <ctype.h>
#define MAXLIGNES 5
#define MAXMOTS 100
#define MOTLEN 25
#define NOMFICH "dictionnaire.dat"

typedef char Ligne[100];

typedef struct{
			 char mot[MOTLEN];
			 int occur;
	  } Dict_elem, *Pelem;

typedef struct {
			 int nelem;
			 Dict_elem mots[MAXMOTS];
			 Pelem pmots[MAXMOTS];
		} Dict;
typedef Ligne Texte[MAXLIGNES];
//Pointeur vers un fonction qi rend entier et qui a 2 parametre de type Pelem
typedef int (*Comparator)(Pelem,Pelem);

void initialDict(Dict*);
void lireDict(Dict *, FILE *);
int lire_texte(Texte, const int maxl);
char *prends_mot_suivant(char *source, char*);
int separer_mots(Texte, Dict*, const int nl, const int maxmot);
void aff_mots(Dict *);
void trie_mots(Dict*,Comparator );
void affichMenu(void);
int searchDict(char *, Dict *d);
void saveDict(Dict *, FILE *);
int compalf(Pelem, Pelem);
int compocc(Pelem, Pelem);

void main (void){
Texte tex;
Dict monDict;
FILE *fichDict;
char command;
int nl, mod=0;

 initialDict(&monDict);
 if  ((fichDict = fopen(NOMFICH,"rb")) != NULL){
	 lireDict(&monDict,fichDict);
	 fclose(fichDict);
 }
  do{    //menu
   affichMenu();
	do {
	 command = toupper(getchar());
	}while (!isalpha(command));
	  fflush(stdin);
	  switch (toupper(command)) {
		  case 'I': initialDict(&monDict);
			 if ( (fichDict = fopen(NOMFICH,"wb")) != NULL) fclose(fichDict);
			 else puts("Erreur d'entree/sortie");
			 break;
		  case 'L' : nl= lire_texte(tex,MAXLIGNES);
				  separer_mots(tex,&monDict,nl,MAXMOTS);
				  mod=1;
				  break;
		  case 'A' :  aff_mots(&monDict);
						  break;
		  case  'T':  trie_mots(&monDict,compalf);
						  mod=1;
						  break;
		  case  'O':   trie_mots(&monDict,compocc);
						  mod=1;
						  break;
		  case 'F':  if (mod) {
							 int ch;
							 printf("Sauver le dicionnaire ? (Y/N):");
							 do {
								 ch = toupper(getchar());
							 }while (!isalpha(ch));
							 if (ch == 'N') break;
						 } else break;
		  case  'S':   if ((fichDict = fopen(NOMFICH,"wb")) != NULL){
							  saveDict(&monDict,fichDict);
							  fclose(fichDict);
							  puts("le dictionnaire est sauvegarde");  getchar();
							  mod=0;
						  }
						  break;

		  default : putchar( '-');putchar(command); getchar();fflush(stdin); break;
	 }   //fin switch
  }while (toupper(command) != 'F') ;
    puts("FIN");
}

 void initialDict(Dict *d){
	int i;
	d->nelem = 0;
	 for (i=0; i<MAXMOTS;i++) d->pmots[i]=&d->mots[i];
 }

 void lireDict(Dict *d, FILE *f){
	int i;
	fread(&d->nelem,sizeof(int),1,f);
	for(i=0; i< d->nelem;i++)
	 fread(d->pmots[i],sizeof(Dict_elem),1,f);
}

 void saveDict(Dict *d, FILE *f){
	int i;
	fwrite(&d->nelem,sizeof(int),1,f);
	for(i=0; i< d->nelem;i++)
	 fwrite(d->pmots[i],sizeof(Dict_elem),1,f);
}

int compalf(Pelem a, Pelem b){
  return strcmp(a->mot,b->mot);
}
int compocc(Pelem a, Pelem b){
	return b->occur-a->occur;
}

int lire_texte(Texte t, const int maxl){
  int i;
  Ligne l;
  for (i=0; i < maxl && gets(l) !=NULL && strlen(l)>0; i++){
	  strcpy(t[i],l);
  }
  return i;
}

char* prends_mot_suivant(char *source, char *mot){
	 char *p = mot;
	 *p = '\0';
	 // sauter les caract'eres qui ne sont pas dans un mot
	 while ( *source != '\0' && ! isalpha(*source)) source++;
	 if ( *source == '\0') return NULL;
	 // separer le mot
	 while (isalpha(*source) || *source =='-') *p++ = *source++;
	 *p = '\0';
	 return source;
}

int separer_mots(Texte tex, Dict *d , const int nl, const int maxmot){
  char *curligne, temp[MOTLEN];
  int l, found;
  for (l=0; l<nl; l++) {
	 curligne = tex[l];
	 while (d->nelem<maxmot &&  curligne !=NULL && *curligne != '\0') {
		 if ((curligne=prends_mot_suivant( curligne,temp)) != NULL){
			  if (( found = searchDict(temp,d)) >=0 )
				 d->mots[found].occur++;
			  else {
				 strcpy(d->mots[d->nelem].mot,temp);
				 d->mots[d->nelem].occur = 1;
				 d->nelem ++ ;
			  }
       }
	 }
  }
  return d->nelem;
}

void aff_mots(Dict *d){
  int i;
  for (i=0;i<d->nelem;i++)
		 printf("%-25s%5d\n",d->pmots[i]->mot,d->pmots[i]->occur);
puts("tapez un caractere"); getchar();fflush(stdin);
}
void trie_mots(Dict *d, Comparator comp){
  // trie les mots a la boule
	Pelem t;
	int i,exch;
	do{
	  exch = 0;
	  for (i=1;i<d->nelem;i++) {
		  if ( (*comp)(d->pmots[i-1],d->pmots[i])>0){
				exch =1;
				t =d->pmots[i-1];
				d->pmots[i-1]=d->pmots[i];
				d->pmots[i]=t;
		  }
		}
	}while (exch);
	}



void affichMenu(void){
  int i;
 for (i=0; i<25; i++) putchar('\n');
  puts("Dictionnaire");
  puts("I. Initialisation");
  puts("L. Lire un texte et separer les mots");
  puts("A. Afficher le dictionnaire");
  puts("T. Trier en ordre alphabetique");
  puts("O. Trier par nombre d'occurences");
  puts("S. Sauvegarder");
  puts("F. Sortie");
  putchar('\n');
  printf("Tapez votre choix :");
}

int searchDict(char * s, Dict *d){
	int i;
	for (i=0; i<d->nelem && strcmp(s,d->mots[i].mot)!=0;i++);
	return (i<d->nelem)? i:-1;
}

